diff -urN bordeaux-threads-0.8.1/src/impl-lispworks.lisp bordeaux-threads-0.8.1.new/src/impl-lispworks.lisp
--- bordeaux-threads-0.8.1/src/impl-lispworks.lisp	2012-04-10 10:32:49.000000000 +0700
+++ bordeaux-threads-0.8.1.new/src/impl-lispworks.lisp	2012-04-17 17:17:45.837710925 +0700
@@ -23,10 +23,15 @@
   (mp:process-run-function name nil function))
 
 (defun current-thread ()
-  mp:*current-process*)
+  #+(or lispworks4 lispworks5.0)
+  mp:*current-process*
+  #-(or lispworks4 lispworks5.0) ;; introduced in LispWorks 5.1
+  (mp:get-current-process))
 
 (defun threadp (object)
-  (typep object 'mp:process))
+  (or (mp:process-p object)
+      #-lispworks6.1                 ;; removed in LispWorks 6.1
+      (mp:simple-process-p object)))
 
 (defun thread-name (thread)
   (mp:process-name thread))
@@ -55,12 +60,12 @@
                 #-(or lispworks4 lispworks5) :recursivep
                 #-(or lispworks4 lispworks5) t))
 
+(declaim (inline acquire-recursive-lock))
 (defun acquire-recursive-lock (lock &optional (wait-p t))
-  (declare (inline acquire-lock))
   (acquire-lock lock wait-p))
 
+(declaim (inline release-recursive-lock))
 (defun release-recursive-lock (lock)
-  (declare (inline release-lock))
   (release-lock lock))
 
 (defmacro with-recursive-lock-held ((place) &body body)
@@ -99,8 +104,11 @@
   (mp:process-alive-p thread))
 
 (defun join-thread (thread)
+  #-lispworks6
   (mp:process-wait (format nil "Waiting for thread ~A to complete" thread)
                    (complement #'mp:process-alive-p)
-                   thread))
+                   thread)
+  #+lispworks6
+  (mp:process-join thread))
 
 (mark-supported)
